clear all
close all

data = importdata('data_Germany_20170101_20201231.txt');

start = 1;                                  % choose the first hour in calibration's window
endd_1 = 371*24;                            % choose the last hour to calibrate the individual model
endd_2 = 366*24;                            % choose the last hour in second window
endd = endd_1 + endd_2;                     % choose the last hour in calibration's window
amount_day_2  = 366;                        % amount of day only in the second window; 
amount_day_3 = 724;                         % amount of day in the third window ;
amount_day = amount_day_2 + amount_day_3;   % amount of day in the second and third window
option = '1';                               % method of finding value of w_ht, which maximalize s_ht
nr_U = 730; %371+366-7;                     % number of scenarios
nr_model = 9;                               % number of models
measures = {'quantile',  'expectiles','ES', 'sharpe', 'q_50_IQR', 'median', 'mean', 'std'};  % measure of risk

m = '1';                                    % chosen of model in ARX model
real_price_RDN = data(endd+1:end,3);        % real prices for the day ahead market in the third window
real_price_RB = data(endd+1:end,4);         % real prices for the complementary market in the third window
prediction_QRA_RB = importdata('prediction_QRA_RB_Germany.txt');  % prediction prices using quantile regression method for the day ahead market
prediction_QRA_RDN = importdata('prediction_QRA_RDN_Germany.txt');% prediction prices using quantile regression method for the complementary market
fname = 'plots_overleaf_fig';               % folder to save figures
model = 'QRA';                              % selected model 
scale_p = 0:0.001:0.01;                     % parameter of scale
price_scenario_RB_saved = importdata('price_scenario_RB_saved.txt');    % predicitons with interpolation for the day-ahead market
price_scenario_RDN_saved = importdata('price_scenario_RDN_saved.txt');  % predicitons with interpolation for the complementary market

%%%%%%%%%%%%%%%%%% Import day profit for all strategies %%%%%%%%%%%%%%%

% quantile
day_profit_05_quantile = load('data_profit_Germany\day_profit_05_quantile.txt');
day_profit_95_quantile = load('data_profit_Germany\day_profit_95_quantile.txt');
% expectiles
day_profit_05_expectiles = load('data_profit_Germany\day_profit_05_expectiles.txt');
day_profit_95_expectiles = load('data_profit_Germany\day_profit_95_expectiles.txt');
% ES
day_profit_05_ES = load('data_profit_Germany\day_profit_05_ES.txt');
day_profit_95_ES = load('data_profit_Germany\day_profit_95_ES.txt');
% sharpe ratio
day_profit_05_sharpe = load('data_profit_Germany\day_profit_05_sharpe.txt');
% q_50_IQR
day_profit_05_q_50_IQR = load('data_profit_Germany\day_profit_05_q_50_IQR.txt');
% q_95_q_5
day_profit_05_median = load('data_profit_Germany\day_profit_05_median.txt');
% mean
day_profit_95_mean = load('data_profit_Germany\day_profit_95_mean.txt');
% std
day_profit_05_std = load('data_profit_Germany\day_profit_05_std.txt');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%% Strategy evaluation metrics %%%%%%%%%%%%%%%%%%%%%%%%%%

% for i = 1:length(measures)
%     measure = cell2mat(measures(i));
%     [std_05, std_95, shape_ratio_weight_05, shape_ratio_weight_95, q50_IQR_weight_05, q50_IQR_weight_95,median_weight_05, median_weight_95, ES_05, ES_95, expectiles_05, expectiles_95, mean_05, mean_95] = strategy_evaluation_metrics_import_data(day_profit_05_quantile,day_profit_95_quantile,day_profit_05_expectiles, day_profit_95_expectiles, day_profit_05_ES, day_profit_95_ES, day_profit_05_sharpe, day_profit_05_q_50_IQR, day_profit_05_median, day_profit_95_mean, day_profit_05_std, measure);
%     switch measure
%             case {'quantile', 'expectiles', 'ES'}
%             std_05_t = std_05;
%             std_95_t = std_95;
%             shape_ratio_weight_05_t = shape_ratio_weight_05;
%             shape_ratio_weight_95_t = shape_ratio_weight_95;
%             q50_IQR_weight_05_t = q50_IQR_weight_05; 
%             q50_IQR_weight_95_t = q50_IQR_weight_95;
%             q95_q5_weight_05_t = median_weight_05;
%             q95_q5_weight_95_t = median_weight_95;
%             ES_05_t = ES_05;
%             ES_95_t = ES_95;
%             expectiles_05_t = expectiles_05;
%             expectiles_95_t = expectiles_95;
%             mean_05_t = mean_05;
%             mean_95_t = mean_95;
% 
%             Strategy = {'Risk minimization (q_05)';'Profit maximization (q_95)'};
%             std = [std_05_t; std_95_t];
%             shape_ratio = [shape_ratio_weight_05_t; shape_ratio_weight_95_t];
%             q50_IQR = [q50_IQR_weight_05_t; q50_IQR_weight_95_t];
%             median = [q95_q5_weight_05_t;q95_q5_weight_95_t];
%             ES = [ES_05_t; ES_95_t];
%             expectiles = [expectiles_05_t; expectiles_95_t];
%             mean = [mean_05_t; mean_95_t];
% 
%            disp('Measure:')
%            disp(measure)
%            Other_risk_measure_QRA = table(Strategy, std, shape_ratio,q50_IQR,median, ES, expectiles, mean)  
%    
%         case {'sharpe', 'q_50_IQR','median','mean', 'std'}
%             std_05_t = std_05;
%             shape_ratio_weight_05_t = shape_ratio_weight_05;
%             q50_IQR_weight_05_t = q50_IQR_weight_05; 
%             q95_q5_weight_05_t = median_weight_05;
%             ES_05_t = ES_05;
%             expectiles_05_t = expectiles_05;
%             mean_05_t = mean_05;
% 
%             Strategy = {'Strategy'};
%             std = [std_05_t];
%             shape_ratio = [shape_ratio_weight_05_t];
%             q50_IQR = [q50_IQR_weight_05_t];
%             median = [q95_q5_weight_05_t];
%             ES = [ES_05_t];
%             expectiles = [expectiles_05_t];
%             mean_05 = [mean_05_t];
% 
%             disp('Measure:')
%             disp(measure)
%             Other_risk_measure_QRA = table(Strategy, std, shape_ratio,q50_IQR, median, ES, expectiles, mean_05)  
%     end    
% end


%%%%%%%%%%%%%%%%%% Import day profit for all strategies %%%%%%%%%%%%%%%

% quantile
day_weight_05_quantile = load('data_profit_Germany\day_weight_05_quantile.txt');
day_weight_95_quantile = load('data_profit_Germany\day_weight_95_quantile.txt');
weight_05_quantile = load('data_profit_Germany\weight_05_quantile.txt');
weight_95_quantile = load('data_profit_Germany\weight_95_quantile.txt');
% expectiles
day_weight_05_expectiles = load('data_profit_Germany\day_weight_05_expectiles.txt');
day_weight_95_expectiles = load('data_profit_Germany\day_weight_95_expectiles.txt');
weight_05_expectiles = load('data_profit_Germany\weight_05_expectiles.txt');
weight_95_expectiles = load('data_profit_Germany\weight_95_expectiles.txt');
% ES
day_weight_05_ES = load('data_profit_Germany\day_weight_05_ES.txt');
day_weight_95_ES = load('data_profit_Germany\day_weight_95_ES.txt');
weight_05_ES = load('data_profit_Germany\weight_05_ES.txt');
weight_95_ES = load('data_profit_Germany\weight_95_ES.txt');
% sharpe ratio
day_weight_05_sharpe = load('data_profit_Germany\day_weight_05_sharpe.txt');
weight_05_sharpe = load('data_profit_Germany\weight_05_sharpe.txt');
% q_50_IQR
day_weight_05_q_50_IQR = load('data_profit_Germany\day_weight_05_q_50_IQR.txt');
weight_05_q_50_IQR = load('data_profit_Germany\weight_05_q_50_IQR.txt');
% q_95_q_5
day_weight_05_median = load('data_profit_Germany\day_weight_05_median.txt');
weight_05_median = load('data_profit_Germany\weight_05_median.txt');
% mean
day_weight_95_mean = load('data_profit_Germany\day_weight_95_mean.txt');
weight_95_mean = load('data_profit_Germany\weight_95_mean.txt');
% std
day_weight_05_std = load('data_profit_Germany\day_weight_05_std.txt');
weight_05_std = load('data_profit_Germany\weight_05_std.txt');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%% Strategy evaluation metrics %%%%%%%%%%%%%%%%%%%%%%%%%%

% Plots of daily profit
% daily_profit_import_data(day_profit_05_quantile,day_profit_95_quantile,day_profit_05_expectiles, day_profit_95_expectiles, day_profit_05_ES, day_profit_95_ES, day_profit_05_sharpe, day_profit_05_q_50_IQR, day_profit_05_median, day_profit_95_mean, day_profit_05_std, fname, model)
   
% Plots of weights
% weights_plots_import_data(day_weight_05_quantile,day_weight_95_quantile,day_weight_05_expectiles, day_weight_95_expectiles, day_weight_05_ES, day_weight_95_ES, day_weight_05_sharpe, day_weight_05_q_50_IQR, day_weight_05_median, day_weight_95_mean, day_weight_05_std, fname, model)

% Plots of hourly weights
% hour_weights_import_data(weight_05_quantile,weight_95_quantile,weight_05_expectiles, weight_95_expectiles, weight_05_ES, weight_95_ES, weight_05_sharpe, weight_05_q_50_IQR, weight_05_median, weight_95_mean, weight_05_std, fname, model);
    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% Strategy evaluation metrics fixed hourly weights %%%%%%%%%%%%%%

% for i = 1:length(measures)
%     measure = cell2mat(measures(i));
%     [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05,  mean_weight_95, std_05, std_95, shape_ratio_weight_05, shape_ratio_weight_95, q50_IQR_weight_05, q50_IQR_weight_95, median_weight_05, median_weight_95, ES_05, ES_95, expectiles_05, expectiles_95, mean_05, mean_95, quantile_95_95, ES_95_95, expectiles_95_95] = strategy_evaluation_metrics_fix_hour_wht(real_price_RDN, real_price_RB, amount_day_3, weight_05_quantile,weight_95_quantile,weight_05_expectiles, weight_95_expectiles, weight_05_ES, weight_95_ES, weight_05_sharpe, weight_05_q_50_IQR, weight_05_median, weight_95_mean, weight_05_std, measure);
%     switch measure
%             case {'quantile', 'expectiles', 'ES'}
%             total_profit_05_t = total_profit_05;
%             total_profit_95_t = total_profit_95;
%             VaR_95_historical_05_t = VaR_95_historical_05;
%             VaR_95_historical_95_t = VaR_95_historical_95;
%             mean_weight_05_t = mean_weight_05;
%             mean_weight_95_t = mean_weight_95;
%             std_05_t = std_05;
%             std_95_t = std_95;
%             shape_ratio_weight_05_t = shape_ratio_weight_05;
%             shape_ratio_weight_95_t = shape_ratio_weight_95;
%             q50_IQR_weight_05_t = q50_IQR_weight_05; 
%             q50_IQR_weight_95_t = q50_IQR_weight_95;
%             q95_q5_weight_05_t = median_weight_05;
%             q95_q5_weight_95_t = median_weight_95;
%             ES_05_t = ES_05;
%             ES_95_t = ES_95;
%             expectiles_05_t = expectiles_05;
%             expectiles_95_t = expectiles_95;
%             mean_05_t = mean_05;
%             mean_95_t = mean_95;
%             quantile_95_95_t = quantile_95_95;
%             ES_95_95_t = ES_95_95;    
%             expectiles_95_95_t = expectiles_95_95;
%             
%             Strategy = {'Risk minimization (q_05)';'Profit maximization (q_95)'};
%             total_profit = [total_profit_05_t; total_profit_95_t];
%             VaR_95_historical = [VaR_95_historical_05_t; VaR_95_historical_95_t];
%             mean_weight = [mean_weight_05_t; mean_weight_95_t];
%             std = [std_05_t; std_95_t];
%             shape_ratio = [shape_ratio_weight_05_t; shape_ratio_weight_95_t];
%             q50_IQR = [q50_IQR_weight_05_t; q50_IQR_weight_95_t];
%             median = [q95_q5_weight_05_t;q95_q5_weight_95_t];
%             ES = [ES_05_t; ES_95_t];
%             expectiles = [expectiles_05_t; expectiles_95_t];
%             mean = [mean_05_t; mean_95_t];
%             % Value calculated only for 95% quantile, 95% expectile, 95% ES
%             quantile_95 = [0 ; quantile_95_95_t];  
%             ES_95_95 = [0 ; ES_95_95_t];
%             expectiles_95_95 = [0 ; expectiles_95_95_t];
% 
%            disp('Measure:')
%            disp(measure)
%            Other_risk_measure_QRA = table(Strategy, total_profit,  VaR_95_historical, mean_weight, std, shape_ratio, q50_IQR, median, ES, expectiles, mean, quantile_95, ES_95_95, expectiles_95_95)  
%    
%         case {'sharpe', 'q_50_IQR','median','mean', 'std'}
%             total_profit_05_t = total_profit_05;
%             VaR_95_historical_05_t = VaR_95_historical_05;
%             mean_weight_05_t = mean_weight_05;
%             std_05_t = std_05;
%             shape_ratio_weight_05_t = shape_ratio_weight_05;
%             q50_IQR_weight_05_t = q50_IQR_weight_05; 
%             q95_q5_weight_05_t = median_weight_05;
%             ES_05_t = ES_05;
%             expectiles_05_t = expectiles_05;
%             mean_05_t = mean_05;
%             
%             Strategy = {'Strategy'};
%             total_profit = [total_profit_05_t];
%             VaR_95_historical = [VaR_95_historical_05_t];
%             mean_weight = [mean_weight_05_t];
%             std = [std_05_t];
%             shape_ratio = [shape_ratio_weight_05_t];
%             q50_IQR = [q50_IQR_weight_05_t];
%             median = [q95_q5_weight_05_t];
%             ES = [ES_05_t];
%             expectiles = [expectiles_05_t];
%             mean_05 = [mean_05_t];
% 
%             disp('Measure:')
%             disp(measure)
%             Other_risk_measure_QRA = table(Strategy, total_profit, VaR_95_historical, mean_weight, std, shape_ratio,q50_IQR, median, ES, expectiles, mean_05)  
%     end    
% end

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%% Strategy evaluation metrics fixed hourly weights company %%%%%%%%%%%%%%
% 
% for i = 1:length(measures)
%     measure = cell2mat(measures(i));
%     [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05,  mean_weight_95, std_05, std_95, shape_ratio_weight_05, shape_ratio_weight_95, q50_IQR_weight_05, q50_IQR_weight_95, median_weight_05, median_weight_95, ES_05, ES_95, expectiles_05, expectiles_95, mean_05, mean_95, quantile_95_95, ES_95_95, expectiles_95_95] = strategy_evaluation_metrics_fix_hour_wht_company(real_price_RDN, real_price_RB, amount_day_3, weight_05_quantile,weight_95_quantile,weight_05_expectiles, weight_95_expectiles, weight_05_ES, weight_95_ES, weight_05_sharpe, weight_05_q_50_IQR, weight_05_median, weight_95_mean, weight_05_std, measure);
%     switch measure
%             case {'quantile', 'expectiles', 'ES'}
%             total_profit_05_t = total_profit_05;
%             total_profit_95_t = total_profit_95;
%             VaR_95_historical_05_t = VaR_95_historical_05;
%             VaR_95_historical_95_t = VaR_95_historical_95;
%             mean_weight_05_t = mean_weight_05;
%             mean_weight_95_t = mean_weight_95;
%             std_05_t = std_05;
%             std_95_t = std_95;
%             shape_ratio_weight_05_t = shape_ratio_weight_05;
%             shape_ratio_weight_95_t = shape_ratio_weight_95;
%             q50_IQR_weight_05_t = q50_IQR_weight_05; 
%             q50_IQR_weight_95_t = q50_IQR_weight_95;
%             q95_q5_weight_05_t = median_weight_05;
%             q95_q5_weight_95_t = median_weight_95;
%             ES_05_t = ES_05;
%             ES_95_t = ES_95;
%             expectiles_05_t = expectiles_05;
%             expectiles_95_t = expectiles_95;
%             mean_05_t = mean_05;
%             mean_95_t = mean_95;
%             quantile_95_95_t = quantile_95_95;
%             ES_95_95_t = ES_95_95;    
%             expectiles_95_95_t = expectiles_95_95;
%             
%             Strategy = {'Risk minimization (q_05)';'Profit maximization (q_95)'};
%             total_profit = [total_profit_05_t; total_profit_95_t];
%             VaR_95_historical = [VaR_95_historical_05_t; VaR_95_historical_95_t];
%             mean_weight = [mean_weight_05_t; mean_weight_95_t];
%             std = [std_05_t; std_95_t];
%             shape_ratio = [shape_ratio_weight_05_t; shape_ratio_weight_95_t];
%             q50_IQR = [q50_IQR_weight_05_t; q50_IQR_weight_95_t];
%             median = [q95_q5_weight_05_t;q95_q5_weight_95_t];
%             ES_5 = [ES_05_t; ES_95_t];
%             expectiles = [expectiles_05_t; expectiles_95_t];
%             mean = [mean_05_t; mean_95_t];
%             % Value calculated only for 95% quantile, 95% expectile, 95% ES
%             quantile_95 = [0 ; quantile_95_95_t];  
%             ES_95_95 = [0 ; ES_95_95_t];
%             expectiles_95_95 = [0 ; expectiles_95_95_t];
% 
%            disp('Measure:')
%            disp(measure)
%            Other_risk_measure_QRA = table(Strategy, total_profit,  VaR_95_historical, mean_weight, std, shape_ratio, q50_IQR, median, ES_5, expectiles, mean, quantile_95, ES_95_95, expectiles_95_95)  
%    
%         case {'sharpe', 'q_50_IQR','median','mean', 'std'}
%             total_profit_05_t = total_profit_05;
%             VaR_95_historical_05_t = VaR_95_historical_05;
%             mean_weight_05_t = mean_weight_05;
%             std_05_t = std_05;
%             shape_ratio_weight_05_t = shape_ratio_weight_05;
%             q50_IQR_weight_05_t = q50_IQR_weight_05; 
%             q95_q5_weight_05_t = median_weight_05;
%             ES_05_t = ES_05;
%             expectiles_05_t = expectiles_05;
%             mean_05_t = mean_05;
%             
%             Strategy = {'Strategy'};
%             total_profit = [total_profit_05_t];
%             VaR_95_historical = [VaR_95_historical_05_t];
%             mean_weight = [mean_weight_05_t];
%             std = [std_05_t];
%             shape_ratio = [shape_ratio_weight_05_t];
%             q50_IQR = [q50_IQR_weight_05_t];
%             median = [q95_q5_weight_05_t];
%             ES = [ES_05_t];
%             expectiles = [expectiles_05_t];
%             mean_05 = [mean_05_t];
% 
%             disp('Measure:')
%             disp(measure)
%             Other_risk_measure_QRA = table(Strategy, total_profit, VaR_95_historical, mean_weight, std, shape_ratio,q50_IQR, median, ES, expectiles, mean_05)  
%     end    
% end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% Strategy evaluation metrics risk company %%%%%%%%%%%%%%

for i = 1:length(measures)
    measure = cell2mat(measures(i));
    [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05,  mean_weight_95, std_05, std_95, shape_ratio_weight_05, shape_ratio_weight_95, q50_IQR_weight_05, q50_IQR_weight_95, median_weight_05, median_weight_95, ES_05, ES_95, expectiles_05, expectiles_95, mean_05, mean_95, quantile_95_95, ES_95_95, expectiles_95_95] = strategy_evaluation_metrics_risk_company(real_price_RDN, real_price_RB, amount_day_3, weight_05_quantile,weight_95_quantile,weight_05_expectiles, weight_95_expectiles, weight_05_ES, weight_95_ES, weight_05_sharpe, weight_05_q_50_IQR, weight_05_median, weight_95_mean, weight_05_std, measure);
    switch measure
            case {'quantile', 'expectiles', 'ES'}
            total_profit_05_t = total_profit_05;
            total_profit_95_t = total_profit_95;
            VaR_95_historical_05_t = VaR_95_historical_05;
            VaR_95_historical_95_t = VaR_95_historical_95;
            mean_weight_05_t = mean_weight_05;
            mean_weight_95_t = mean_weight_95;
            std_05_t = std_05;
            std_95_t = std_95;
            shape_ratio_weight_05_t = shape_ratio_weight_05;
            shape_ratio_weight_95_t = shape_ratio_weight_95;
            q50_IQR_weight_05_t = q50_IQR_weight_05; 
            q50_IQR_weight_95_t = q50_IQR_weight_95;
            q95_q5_weight_05_t = median_weight_05;
            q95_q5_weight_95_t = median_weight_95;
            ES_05_t = ES_05;
            ES_95_t = ES_95;
            expectiles_05_t = expectiles_05;
            expectiles_95_t = expectiles_95;
            mean_05_t = mean_05;
            mean_95_t = mean_95;
            quantile_95_95_t = quantile_95_95;
            ES_95_95_t = ES_95_95;    
            expectiles_95_95_t = expectiles_95_95;
            
            Strategy = {'Risk minimization (q_05)';'Profit maximization (q_95)'};
            total_profit = [total_profit_05_t; total_profit_95_t];
            VaR_95_historical = [VaR_95_historical_05_t; VaR_95_historical_95_t];
            mean_weight = [mean_weight_05_t; mean_weight_95_t];
            std = [std_05_t; std_95_t];
            shape_ratio = [shape_ratio_weight_05_t; shape_ratio_weight_95_t];
            q50_IQR = [q50_IQR_weight_05_t; q50_IQR_weight_95_t];
            median = [q95_q5_weight_05_t;q95_q5_weight_95_t];
            ES_5 = [ES_05_t; ES_95_t];
            expectiles = [expectiles_05_t; expectiles_95_t];
            mean = [mean_05_t; mean_95_t];
            % Value calculated only for 95% quantile, 95% expectile, 95% ES
            quantile_95 = [0 ; quantile_95_95_t];  
            ES_95_95 = [0 ; ES_95_95_t];
            expectiles_95_95 = [0 ; expectiles_95_95_t];

           disp('Measure:')
           disp(measure)
           Other_risk_measure_QRA = table(Strategy, total_profit,  VaR_95_historical, mean_weight, std, shape_ratio, q50_IQR, median, ES_5, expectiles, mean, quantile_95, ES_95_95, expectiles_95_95)  
   
        case {'sharpe', 'q_50_IQR','median','mean', 'std'}
            total_profit_05_t = total_profit_05;
            VaR_95_historical_05_t = VaR_95_historical_05;
            mean_weight_05_t = mean_weight_05;
            std_05_t = std_05;
            shape_ratio_weight_05_t = shape_ratio_weight_05;
            q50_IQR_weight_05_t = q50_IQR_weight_05; 
            q95_q5_weight_05_t = median_weight_05;
            ES_05_t = ES_05;
            expectiles_05_t = expectiles_05;
            mean_05_t = mean_05;
            
            Strategy = {'Strategy'};
            total_profit = [total_profit_05_t];
            VaR_95_historical = [VaR_95_historical_05_t];
            mean_weight = [mean_weight_05_t];
            std = [std_05_t];
            shape_ratio = [shape_ratio_weight_05_t];
            q50_IQR = [q50_IQR_weight_05_t];
            median = [q95_q5_weight_05_t];
            ES = [ES_05_t];
            expectiles = [expectiles_05_t];
            mean_05 = [mean_05_t];

            disp('Measure:')
            disp(measure)
            Other_risk_measure_QRA = table(Strategy, total_profit, VaR_95_historical, mean_weight, std, shape_ratio,q50_IQR, median, ES, expectiles, mean_05)  
    end    
end


%%%%%%%%%%%%%%%%%%%%%% For rescaled prices %%%%%%%%%%%%%%%%%%%%%%%%%%

format long g
scale = scale_p;
% [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05, mean_weight_95]= strategy_evaluation_metrics_scale_price(real_price_RDN, real_price_RB, amount_day_3, price_scenario_RB_saved, price_scenario_RDN_saved, nr_U, option, 'quantile', scale_p);
% results_rescaled_prices_quantile = zeros(6,11);
% results_rescaled_prices_quantile(1,:) = total_profit_05;
% results_rescaled_prices_quantile(2,:) = VaR_95_historical_05;
% results_rescaled_prices_quantile(3,:) = mean_weight_05;
% results_rescaled_prices_quantile(4,:) = total_profit_95;
% results_rescaled_prices_quantile(5,:) = VaR_95_historical_95;
% results_rescaled_prices_quantile(6,:) = mean_weight_95;
% row = ['Scaling parameter - S' num2cell(scale)];
% risk_measures = {'profit (5 % quantile)','VaR_{5%} (5 % quantile)', 'mean weight (5 % quantile)', 'profit (95 % quantile)', 'VaR_{5%} (95 % quantile)', 'mean weight (95 % quantile)'};
% results_rescaled_prices_quantile_f = [risk_measures', num2cell(results_rescaled_prices_quantile)];
% results_rescaled_prices_quantile_final = [row; results_rescaled_prices_quantile_f];

% [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05, mean_weight_95]= strategy_evaluation_metrics_scale_price(real_price_RDN, real_price_RB, amount_day_3, price_scenario_RB_saved, price_scenario_RDN_saved, nr_U, option, 'mean', scale_p);
% results_rescaled_prices_mean = zeros(3,11);
% results_rescaled_prices_mean(1,:) = total_profit_95;
% results_rescaled_prices_mean(2,:) = VaR_95_historical_95;
% results_rescaled_prices_mean(3,:) = mean_weight_95;
% row = ['Scaling parameter - S' num2cell(scale)];
% risk_measures = {'profit (mean)','VaR_{5%} (mean)', 'mean weight (mean)'};
% results_rescaled_prices_mean_f = [risk_measures', num2cell(results_rescaled_prices_mean)];
% results_rescaled_prices_mean_final = [row; results_rescaled_prices_mean_f];

% %%%%%%%%%%%%%%%%%%%%%% For rescaled forecasts %%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05,  mean_weight_95]= strategy_evaluation_metrics_scale_forecast(real_price_RDN, real_price_RB, amount_day_3, nr_U, option, price_scenario_RB_saved, price_scenario_RDN_saved,'quantile', scale_p);
% results_rescaled_forecast_quantile = zeros(6,11);
% results_rescaled_forecast_quantile(1,:) = total_profit_05;
% results_rescaled_forecast_quantile(2,:) = VaR_95_historical_05;
% results_rescaled_forecast_quantile(3,:) = mean_weight_05;
% results_rescaled_forecast_quantile(4,:) = total_profit_95;
% results_rescaled_forecast_quantile(5,:) = VaR_95_historical_95;
% results_rescaled_forecast_quantile(6,:) = mean_weight_95;
% row = ['Scaling parameter - S' num2cell(scale)];
% risk_measures = {'profit (5 % quantile)','VaR_{5%} (5 % quantile)', 'mean weight (5 % quantile)', 'profit (95 % quantile)', 'VaR_{5%} (95 % quantile)', 'mean weight (95 % quantile)'};
% results_rescaled_forecast_quantile_f = [risk_measures', num2cell(results_rescaled_forecast_quantile)];
% results_rescaled_forecast_quantile_final = [row; results_rescaled_forecast_quantile_f];

% [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05,  mean_weight_95]= strategy_evaluation_metrics_scale_forecast(real_price_RDN, real_price_RB, amount_day_3, nr_U, option, price_scenario_RB_saved, price_scenario_RDN_saved, 'mean', scale_p);
% results_rescaled_forecast_mean = zeros(3,11);
% results_rescaled_forecast_mean(1,:) = total_profit_95;
% results_rescaled_forecast_mean(2,:) = VaR_95_historical_95;
% results_rescaled_forecast_mean(3,:) = mean_weight_95;
% row = ['Scaling parameter - S' num2cell(scale)];
% risk_measures = {'profit (mean)','VaR_{5%} (mean)', 'mean weight (mean)'};
% results_rescaled_forecast_mean_f = [risk_measures', num2cell(results_rescaled_forecast_mean)];
% results_rescaled_forecast_mean_final = [row; results_rescaled_forecast_mean_f];
