clear all
close all

data = importdata('data_Germany_20170101_20201231.txt');

start = 1;                                  % choose the first hour in calibration's window
endd_1 = 371*24;                            % choose the last hour to calibrate the individual model
endd_2 = 366*24;                            % choose the last hour in second window
endd = endd_1 + endd_2;                     % choose the last hour in calibration's window
amount_day_2  = 366;                        % amount of day only in the second window; 
amount_day_3 = 724;                         % amount of day in the third window ;
amount_day = amount_day_2 + amount_day_3;   % amount of day in the second and third window
option = '1';                               % method of finding value of w_ht, which maximalize s_ht
nr_U = 730; %371+366-7;                     % number of scenarios
nr_model = 9;                               % number of models
measures = {'quantile', 'expectiles','ES', 'sharpe', 'q_50_IQR', 'median', 'mean', 'std'};  % measure of risk

list_m = {'1','2','3','4','5','6','7','8','9'}; % list of models
real_price_RDN = data(endd+1:end,3);        % real prices for the day ahead market in the third window
real_price_RB = data(endd+1:end,4);         % real prices for the complementary market in the third window
prediction_QRA_RB = importdata('prediction_QRA_RB_Germany.txt');  % prediction prices using quantile regression method for the day ahead market
prediction_QRA_RDN = importdata('prediction_QRA_RDN_Germany.txt');% prediction prices using quantile regression method for the complementary market

weights_all_single = [0.3576, 0.4061, 0.4257, 0.3904, 0.3798, 0.3591, 0.6256, 0.6062, 0.7922, 0.4712, 0.4630];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%% Probability forecast of single model %%%%%%%%%%%%

% [price_scenario_single_model_RDN_1, price_scenario_single_model_RB_1] = prediction_ARX_RDN_RB_with_residua(data, start, endd, amount_day_3,nr_U, '1');
% [price_scenario_single_model_RDN_2, price_scenario_single_model_RB_2] = prediction_ARX_RDN_RB_with_residua(data, start, endd, amount_day_3,nr_U, '2');
% [price_scenario_single_model_RDN_3, price_scenario_single_model_RB_3] = prediction_ARX_RDN_RB_with_residua(data, start, endd, amount_day_3,nr_U, '3');
% [price_scenario_single_model_RDN_4, price_scenario_single_model_RB_4] = prediction_ARX_RDN_RB_with_residua(data, start, endd, amount_day_3,nr_U, '4');
% [price_scenario_single_model_RDN_5, price_scenario_single_model_RB_5] = prediction_ARX_RDN_RB_with_residua(data, start, endd, amount_day_3,nr_U, '5');
% [price_scenario_single_model_RDN_6, price_scenario_single_model_RB_6] = prediction_ARX_RDN_RB_with_residua(data, start, endd, amount_day_3,nr_U, '6');
% [price_scenario_single_model_RDN_7, price_scenario_single_model_RB_7] = prediction_ARX_RDN_RB_with_residua(data, start, endd, amount_day_3,nr_U, '7');
% [price_scenario_single_model_RDN_8, price_scenario_single_model_RB_8] = prediction_ARX_RDN_RB_with_residua(data, start, endd, amount_day_3,nr_U, '8');
% [price_scenario_single_model_RDN_9, price_scenario_single_model_RB_9] = prediction_ARX_RDN_RB_with_residua(data, start, endd, amount_day_3,nr_U, '9');


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%% Optimal scenarios  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% % For the single models 
% final_weights_single_model_quantile = zeros(2*nr_model, amount_day_3*24);
% final_weights_single_model_expectiles = zeros(2*nr_model, amount_day_3*24);
% final_weights_single_model_ES = zeros(2*nr_model, amount_day_3*24);
% final_weights_single_model_sharpe = zeros(2*nr_model, amount_day_3*24);
% final_weights_single_model_q_50_IQR = zeros(2*nr_model, amount_day_3*24);
% final_weights_single_model_median = zeros(2*nr_model, amount_day_3*24);
% final_weights_single_model_mean = zeros(2*nr_model, amount_day_3*24);
% final_weights_single_model_std = zeros(2*nr_model, amount_day_3*24);
% 
% 
% for i = 1:nr_model
%     m = cell2mat(list_m(i));
%     final_weights_single_model_quantile(i:i+1,:) = optimal_scenarios_single_model(data, start, endd, amount_day_3,nr_U, m,option, 'quantile');
%     final_weights_single_model_expectiles(i:i+1,:) = optimal_scenarios_single_model(data, start, endd, amount_day_3,nr_U, m,option, 'expectiles');
%     final_weights_single_model_ES(i:i+1,:) = optimal_scenarios_single_model(data, start, endd, amount_day_3,nr_U, m,option, 'ES');
%     final_weights_single_model_sharpe(i:i+1,:) = optimal_scenarios_single_model(data, start, endd, amount_day_3,nr_U, m,option, 'sharpe');
%     final_weights_single_model_q_50_IQR(i:i+1,:) = optimal_scenarios_single_model(data, start, endd, amount_day_3,nr_U, m,option, 'q_50_IQR');
%     final_weights_single_model_median(i:i+1,:) = optimal_scenarios_single_model(data, start, endd, amount_day_3,nr_U, m,option, 'median');
%     final_weights_single_model_mean(i:i+1,:) = optimal_scenarios_single_model(data, start, endd, amount_day_3,nr_U, m,option, 'mean');
%     final_weights_single_model_std(i:i+1,:) = optimal_scenarios_single_model(data, start, endd, amount_day_3,nr_U, m,option, 'std');
% end


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%% Strategy evaluation metrics %%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% % For the single model 
% profit_VaR_weight_Guantile = zeros(nr_model, 6);
% profit_VaR_weight_Expectiles = zeros(nr_model, 6);
% profit_VaR_weight_ES = zeros(nr_model, 6);
% profit_VaR_weight_Sharpe = zeros(nr_model, 3);
% profit_VaR_weight_q_50_IQR = zeros(nr_model, 3);
% profit_VaR_weight_Median = zeros(nr_model, 3);
% profit_VaR_weight_Mean = zeros(nr_model, 3);
% profit_VaR_weight_Std = zeros(nr_model, 3);
% 
% for i = 1:nr_model
%     m = cell2mat(list_m(i));
%     % Measure: QUANTILE
%     [total_profit_05, total_profit_95, VaR_95_historical_05, VaR_95_historical_95, mean_weight_05, mean_weight_95] = strategy_evaluation_metrics_single_model(data, start, endd, amount_day_3,nr_U, m,option, real_price_RDN, real_price_RB, 'quantile');
%     profit_VaR_weight_Guantile(m,1) =  total_profit_05;
%     profit_VaR_weight_Guantile(m,2) =  total_profit_95;
%     profit_VaR_weight_Guantile(m,3) =  VaR_95_historical_05;
%     profit_VaR_weight_Guantile(m,4) =  VaR_95_historical_95;
%     profit_VaR_weight_Guantile(m,5) =  mean_weight_05;
%     profit_VaR_weight_Guantile(m,6) =  mean_weight_95;
%     
%     % Measure: EXPECTILES
%     [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05, mean_weight_95] = strategy_evaluation_metrics_single_model(data, start, endd, amount_day_3,nr_U, m,option, real_price_RDN, real_price_RB, 'expectiles');
%     profit_VaR_weight_Expectiles(m,1) =  total_profit_05;
%     profit_VaR_weight_Expectiles(m,2) =  total_profit_95;
%     profit_VaR_weight_Expectiles(m,3) =  VaR_95_historical_05;
%     profit_VaR_weight_Expectiles(m,4) =  VaR_95_historical_95;
%     profit_VaR_weight_Expectiles(m,5) =  mean_weight_05;
%     profit_VaR_weight_Expectiles(m,6) =  mean_weight_95;
%     
%     % Measure: ES
%     [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05, mean_weight_95] = strategy_evaluation_metrics_single_model(data, start, endd, amount_day_3,nr_U, m,option, real_price_RDN, real_price_RB, 'ES');
%     profit_VaR_weight_ES(m,1) =  total_profit_05;
%     profit_VaR_weight_ES(m,2) =  total_profit_95;
%     profit_VaR_weight_ES(m,3) =  VaR_95_historical_05;
%     profit_VaR_weight_ES(m,4) =  VaR_95_historical_95;
%     profit_VaR_weight_ES(m,5) =  mean_weight_05;
%     profit_VaR_weight_ES(m,6) =  mean_weight_95;
%     
%     
%     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     % For 'sharpe', 'q_50_IQR', 'mean', 'median', 'std' the total profit,
%     % VaR and weight are the same for two considered orders ????? 
%     
%     % Measure: SHARPE
%     [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05, mean_weight_95] = strategy_evaluation_metrics_single_model(data, start, endd, amount_day_3,nr_U, m,option, real_price_RDN, real_price_RB, 'sharpe');
%     profit_VaR_weight_Sharpe(m,1) =  total_profit_05;
%     profit_VaR_weight_Sharpe(m,2) =  VaR_95_historical_05;
%     profit_VaR_weight_Sharpe(m,3) =  mean_weight_05;
%     
%     % Measure: q_50_IQR
%     [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05, mean_weight_95] = strategy_evaluation_metrics_single_model(data, start, endd, amount_day_3,nr_U, m,option, real_price_RDN, real_price_RB, 'q_50_IQR');
%     profit_VaR_weight_q_50_IQR(m,1) =  total_profit_05;
%     profit_VaR_weight_q_50_IQR(m,2) =  VaR_95_historical_05;
%     profit_VaR_weight_q_50_IQR(m,3) =  mean_weight_05;
%     
%     % Measure: MEDIAN
%     [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05, mean_weight_95] = strategy_evaluation_metrics_single_model(data, start, endd, amount_day_3,nr_U, m,option, real_price_RDN, real_price_RB, 'median');
%     profit_VaR_weight_Median(m,1) =  total_profit_05;
%     profit_VaR_weight_Median(m,2) =  VaR_95_historical_05;
%     profit_VaR_weight_Median(m,3) =  mean_weight_05;
%     
%     % Measure: MEAN
%     [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05, mean_weight_95] = strategy_evaluation_metrics_single_model(data, start, endd, amount_day_3,nr_U, m,option, real_price_RDN, real_price_RB, 'mean');
%     profit_VaR_weight_Mean(m,1) =  total_profit_05;
%     profit_VaR_weight_Mean(m,2) =  VaR_95_historical_05;
%     profit_VaR_weight_Mean(m,3) =  mean_weight_05;
%     
%     % Measure: VOLATILITY
%     [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05, mean_weight_95] = strategy_evaluation_metrics_single_model(data, start, endd, amount_day_3,nr_U, m,option, real_price_RDN, real_price_RB, 'std');
%     profit_VaR_weight_Std(m,1) =  total_profit_05;
%     profit_VaR_weight_Std(m,2) =  VaR_95_historical_05;
%     profit_VaR_weight_Std(m,3) =  mean_weight_05;
%     
% end


% %%%%%%%%%%%%%%%%%%%%%%%%% For fix weights %%%%%%%%%%%%%%%%%%%%%%%
% 
% results_fix_weight_single = zeros(length(weights_all_single), 12);
% 
% for i = 1:length(weights_all_single)
%     weights = weights_all_single(i);
%     [total_profit_wht_fix, VaR_95_historical_wht_fix, quantile_95_95, std_wht_fix, sharpe_ratio_wht_fix, q50_IQR_wht_fix,median_wht_fix, ES_wht_fix_05,ES_wht_fix_95, expectiles_wht_fix_05, expectiles_wht_fix_95, mean_wht_fix]= strategy_evaluation_metrics_fix_wht(real_price_RDN, real_price_RB, amount_day_3, weights);
%     results_fix_weight_single(i, 1) = total_profit_wht_fix;
%     results_fix_weight_single(i, 2) = VaR_95_historical_wht_fix;
%     results_fix_weight_single(i, 3) = quantile_95_95;
%     results_fix_weight_single(i, 4) = std_wht_fix;
%     results_fix_weight_single(i, 5) = sharpe_ratio_wht_fix;
%     results_fix_weight_single(i, 6) = q50_IQR_wht_fix;
%     results_fix_weight_single(i, 7) = median_wht_fix;
%     results_fix_weight_single(i, 8) = ES_wht_fix_05;
%     results_fix_weight_single(i, 9) = ES_wht_fix_95;
%     results_fix_weight_single(i, 10) = expectiles_wht_fix_05;
%     results_fix_weight_single(i, 11) = expectiles_wht_fix_95;
%     results_fix_weight_single(i, 12) = mean_wht_fix;
% end
% 
% evaluation = {'Evaluation','Profit', '5% VaR', '95% quantile', 'Std', 'Sharpe','MIQR','Median','5% ES', '95% ES','5% expectile', '95% expectile', 'Mean'};
% risk_measures = {'5% quantile', '5% expectile','5% ES', 'Volatility','Sharpe ratio', 'q_50_IQR', '95% quantile', '95% expectile','95% ES', 'mean', 'median'};
% results_fix_weight_single_f = [risk_measures' num2cell(results_fix_weight_single)];
% results_fix_weight_single_final = [evaluation; results_fix_weight_single_f];
