function hour_weights_import_data(weight_05_quantile,weight_95_quantile,weight_05_expectiles, weight_95_expectiles, weight_05_ES, weight_95_ES, weight_05_sharpe, weight_05_q_50_IQR, weight_05_median, weight_95_mean, weight_05_std, fname, model)
   
    % Comparison of average weight for particular hour
    avg_weight_05_quantile = zeros(1,24);
    avg_weight_95_quantile = zeros(1,24);
    avg_weight_05_expectiles = zeros(1,24);
    avg_weight_95_expectiles = zeros(1,24);
    avg_weight_05_ES = zeros(1,24);
    avg_weight_95_ES = zeros(1,24);
    avg_weight_05_sharpe = zeros(1,24);
    avg_weight_05_q_50_IQR = zeros(1,24);
    avg_weight_05_median = zeros(1,24);
    avg_weight_95_mean = zeros(1,24);
    avg_weight_05_std = zeros(1,24);
    
    % hour weight
    for i = 1:24
        avg_weight_05_quantile(i) = mean(weight_05_quantile(i:24:end));
        avg_weight_95_quantile(i) = mean(weight_95_quantile(i:24:end));
        avg_weight_05_expectiles(i) = mean(weight_05_expectiles(i:24:end));
        avg_weight_95_expectiles(i) = mean(weight_95_expectiles(i:24:end));
        avg_weight_05_ES(i) = mean(weight_05_ES(i:24:end));
        avg_weight_95_ES(i) = mean(weight_95_ES(i:24:end));
        avg_weight_05_sharpe(i) = mean(weight_05_sharpe(i:24:end));
        avg_weight_05_q_50_IQR(i) = mean(weight_05_q_50_IQR(i:24:end));
        avg_weight_05_median(i) = mean(weight_05_median(i:24:end));
        avg_weight_95_mean(i) = mean(weight_95_mean(i:24:end));
        avg_weight_05_std(i) = mean(weight_05_std(i:24:end));
    end    
    
    %%%%%%%%%%%%%%%%%%%%%%% Plots for risk minimization %%%%%%%%%%%%%%%%%%%%
 
    % Comparison of hourly weights
    
    figure
    h = subplot(1,3,1);
    set(h,'position',[0.0633333333333333 0.182692307692308 0.267395833333333 0.758333333333333]);
    hold on
    plot(avg_weight_05_quantile,'Color',[0.9290, 0.6940, 0.1250])
    plot(avg_weight_05_expectiles, 'Color',[0.4660, 0.6740, 0.1880])
    plot(avg_weight_05_ES, 'm')
    plot(avg_weight_05_std, 'Color',[0, 0.4470, 0.7410])
    xlim([1, length(avg_weight_05_quantile)])
    ylim([0,1])
   % xlabel('Date [08.01.2019 - 31.12.2020]', 'fontsize',13)
    xlabel('Hour', 'fontsize',13)
    ylabel('Share on intraday market', 'fontsize',15)
    legend('quantile', 'expectiles', 'ES', 'std')
%     title('Comparison of average hourly weights for different risk measures of risk minimization strategy')
    title('Risk minimization strategy')
%     set(gca, 'YTick', [0.2,0.4, 0.6, 0.8])
    set(gca,'fontsize',20)
    box on
    hold off
    
      %%%%%%%%%%%%%%%%%%%%%%% Plots for optimal strategy %%%%%%%%%%%%%%%%%%%%
    
    % Comparison of daily profits 
    h1 = subplot(1,3,2);
    set(h1,'position',[0.3953125 0.179487179487179 0.268229166666667 0.767948717948718]);
    hold on
    plot(avg_weight_05_sharpe, 'm')
    plot(avg_weight_05_q_50_IQR,'Color', [0.4660, 0.6740, 0.1880])
    %plot(day_weight_05_median, 'Color', [0.9290, 0.6940, 0.1250])
    xlim([1, length(avg_weight_05_sharpe)])
    ylim([0,1])
%     ylabel('Share on intraday market', 'fontsize',15)
    xlabel('Hour', 'fontsize',13)
    legend('sharpe ratio', 'q_{50}/IQR') %, 'median')
%     title('Comparison of average hourly weights for different risk measures of optimal strategy')
    title('Optimal strategy')
%     set(gca, 'YTick', [0.2,0.4,0.6,0.8])
    set(gca,'fontsize',20)
    box on
    hold off 
    
    %%%%%%%%%%%%%%%%%%%%%%% Plots for profit maximization %%%%%%%%%%%%%%%%%%%%
    
    % Comparison of daily profits 
    h2 = subplot(1,3,3);
    set(h2,'position', [0.730729166666667 0.182692307692308 0.25864583333333 0.76474358974359]);
    hold on
    plot(avg_weight_95_quantile,'Color',[0, 0.4470, 0.7410])
    plot(avg_weight_95_expectiles,'m')
    plot(avg_weight_95_mean,'Color',[0.9290, 0.6940, 0.1250])
    plot(avg_weight_95_ES, 'Color',[0.4660, 0.6740, 0.1880])
    plot(avg_weight_05_median,'Color', [0.8500, 0.3250, 0.0980])
    xlim([1, length(avg_weight_95_quantile)])
    ylim([0,1])
    xlabel('Hour', 'fontsize',13)
%     ylabel('Share on intraday market', 'fontsize',15)
    legend('quantile', 'expectiles','mean','ES', 'median')
%     title('Comparison of average hourly weights for different risk measures of profit maximization strategy')
    title('Profit maximization strategy')
%     set(gca, 'YTick', [0.3,0.5,0.7, 0.9])
    set(gca,'fontsize',20)
    box on
    hold off
    switch model
        case 'QRA'
            saveas(gca, fullfile(fname, 'sub_hourly_weight_Germany'), 'fig');
        case 'single'  
            saveas(gca, fullfile(fname, 'sub_hourly_weight_Germany_single'), 'fig');
    end
 
end
