function [price_scenario_single_model_RDN, price_scenario_single_model_RB] = prediction_ARX_RDN_RB_with_residua(data, start, endd, amount_day_3,nr_U, m)

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%% Input data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    % data - input data
    % start - choose the first hour in calibration's window 
    % endd -  choose the last hour in calibration's window 
    % amount_day_3 - amount of day in validation's window 
    % nr_U - number of scenarios
    % m - chosen of model in ARX model

    result_ARX_RDN = zeros(amount_day_3*24,4);
    result_ARX_RB = zeros(amount_day_3*24,4);
    residua_ARX_RDN = zeros(amount_day_3*24,nr_U);
    residua_ARX_RB = zeros(amount_day_3*24,nr_U);

    for k = 1:amount_day_3
        result_ARX_RDN((k-1)*24+1:k*24,1:3) = data(endd + (k-1)*24+1 : endd+k*24,1:3);
        result_ARX_RB((k-1)*24+1:k*24,1:2) = data(endd + (k-1)*24+1 : endd+k*24,1:2);
        result_ARX_RB((k-1)*24+1:k*24,3) = data(endd + (k-1)*24+1 : endd+k*24,4);

        % Estimation of model
        [forecast_for_day_RDN, residua_RDN] = model_ARX_RDN_with_residua(data(start+(k-1)*24:endd+k*24,:),m, nr_U);
        [forecast_for_day_RB, residua_RB] = model_ARX_RB_with_residua(data(start+(k-1)*24:endd+k*24,:),m, nr_U);
       
        % Fill 4th column of matrix using forecast prices
        result_ARX_RDN((k-1)*24+1:k*24,4) = forecast_for_day_RDN;
        result_ARX_RB((k-1)*24+1:k*24,4) = forecast_for_day_RB;

        % residua
        residua_ARX_RDN((k-1)*24+1:k*24,:)= residua_RDN;
        residua_ARX_RB((k-1)*24+1:k*24,:)= residua_RB;
    end


    % Create the probabilistic forecast only for the third window for single model
    price_scenario_single_model_RDN = zeros(amount_day_3*24, nr_U);
    price_scenario_single_model_RB = zeros(amount_day_3*24, nr_U);
    prediction_price_3_window_RDN = result_ARX_RDN(:,4);
    prediction_price_3_window_RB = result_ARX_RB(:,4);
    
 
    for k = 1:amount_day_3
        for i = 1:nr_U % number of residua, so number of scenarios
            price_scenario_single_model_RDN((k-1)*24+1:k*24,i) = prediction_price_3_window_RDN((k-1)*24+1:k*24)+ residua_ARX_RDN((k-1)*24+1:k*24,i);
            price_scenario_single_model_RB((k-1)*24+1:k*24,i) = prediction_price_3_window_RB((k-1)*24+1:k*24)+ residua_ARX_RB((k-1)*24+1:k*24,i);
        end
    end
end
