function [total_profit_wht_fix, VaR_95_historical_wht_fix, quantile_95_95, std_wht_fix, sharpe_ratio_wht_fix, q50_IQR_wht_fix,median_wht_fix, ES_wht_fix_05,ES_wht_fix_95, expectiles_wht_fix_05, expectiles_wht_fix_95, mean_wht_fix]= strategy_evaluation_metrics_fix_wht_company(real_price_RDN, real_price_RB, amount_day_3, weights)


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Input data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % amount_day_3 - amount of day in validation's window = 390;
    % real_price_RB - real prices for the day ahead market in the third window
    % real_price_RDN - real prices for the complementary market in the third window
    % weights - fixed weights

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Hourly profit %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    profit_wht_fix = zeros(amount_day_3*24,1);

    for i = 1:amount_day_3*24
        profit_wht_fix(i) = weights* real_price_RB(i) + (1 - weights)* real_price_RDN(i);
    end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Total profit %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    total_profit_wht_fix = sum(profit_wht_fix);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 5% Value atRisk (VaR) %%%%%%%%%%%%%%%%%%%%%%
    day_profit_wht_fix = zeros(amount_day_3,1);

    for k = 1:amount_day_3  % SUM czy MEAN tutaj? 
        day_profit_wht_fix(k) = sum(profit_wht_fix((k-1)*24+1:k*24)); % było 'sum'
    end

    % VaR 
    VaR_95_historical_wht_fix = quantile(day_profit_wht_fix,0.05);
    
    % Quantile 95%
    quantile_95_95 = quantile(day_profit_wht_fix,0.95);
    
    % Volatility
    std_wht_fix = std(day_profit_wht_fix);
    
    % Shape ratio
    sharpe_ratio_wht_fix = mean(day_profit_wht_fix)/std(day_profit_wht_fix);
    
    q50_IQR_wht_fix = quantile(day_profit_wht_fix,0.5)/iqr(day_profit_wht_fix);
    
    % Median
    median_wht_fix = median(day_profit_wht_fix);
    
    % Expected shortfall
    index = find(day_profit_wht_fix < VaR_95_historical_wht_fix);
    help_vec = zeros(1,length(index));
    for z = 1:length(index)
        help_vec(z) = day_profit_wht_fix(index(z));
    end
    
    ES_wht_fix_05 = mean(help_vec);  % below VaR
    
    % Expected shortfall 95%
    index_95 = find(day_profit_wht_fix > quantile_95_95);
    help_vec_95_95 = zeros(1,length(index_95));
    for z = 1:length(index_95)
        help_vec_95_95(z) = day_profit_wht_fix(index_95(z));
    end
    ES_wht_fix_95 = mean(help_vec_95_95); % above VaR
    
    % Expectiles 5%
    expectiles_wht_fix_05 = expectile(day_profit_wht_fix,0.05);
    expectiles_wht_fix_95 = expectile(day_profit_wht_fix,0.95);
    
    % Mean
    mean_wht_fix = mean(day_profit_wht_fix);
   
end
