function [std_05, std_95, shape_ratio_weight_05, shape_ratio_weight_95, q50_IQR_weight_05, q50_IQR_weight_95,median_weight_05, median_weight_95, ES_05, ES_95, expectiles_05, expectiles_95, mean_05, mean_95] = strategy_evaluation_metrics_import_data(day_profit_05_quantile,day_profit_95_quantile,day_profit_05_expectiles, day_profit_95_expectiles, day_profit_05_ES, day_profit_95_ES, day_profit_05_sharpe, day_profit_05_q_50_IQR, day_profit_05_median, day_profit_95_mean, day_profit_05_std, measure)
   
% [quantile_95_95, ES_95_95, expectiles_95_95] = strategy_evaluation_metrics_import_data(day_profit_05_quantile,day_profit_95_quantile,day_profit_05_expectiles, day_profit_95_expectiles, day_profit_05_ES, day_profit_95_ES, day_profit_05_sharpe, day_profit_05_q_50_IQR, day_profit_05_median, day_profit_95_mean, day_profit_05_std, measure)
% [std_05, std_95, shape_ratio_weight_05, shape_ratio_weight_95, q50_IQR_weight_05, q50_IQR_weight_95,median_weight_05, median_weight_95, ES_05, ES_95, expectiles_05, expectiles_95, mean_05, mean_95] = strategy_evaluation_metrics_import_data(day_profit_05_quantile,day_profit_95_quantile,day_profit_05_expectiles, day_profit_95_expectiles, day_profit_05_ES, day_profit_95_ES, day_profit_05_sharpe, day_profit_05_q_50_IQR, day_profit_05_median, day_profit_95_mean, day_profit_05_std, measure)
   
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Input data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
    % As an input data are given the files 'txt' contain the daily profit 
    % for different risk measures and name of measure. 
 
    %%%%%%%%%%%%%%%%%%%%%% Chosing the strategy %%%%%%%%%%%%%%%%%%%%%%%%%%%
    switch measure 
        case 'quantile'
            day_profit_05 = day_profit_05_quantile;
            day_profit_95 = day_profit_95_quantile;
        case 'expectiles'  
            day_profit_05 = day_profit_05_expectiles;
            day_profit_95 = day_profit_95_expectiles;
        case 'ES'
            day_profit_05 = day_profit_05_ES;
            day_profit_95 = day_profit_95_ES;
        case 'sharpe'  
            day_profit_05 = day_profit_05_sharpe;
            day_profit_95 = day_profit_05_sharpe;
        case 'q_50_IQR' 
            day_profit_05 = day_profit_05_q_50_IQR;
            day_profit_95 = day_profit_05_q_50_IQR;
        case 'median' 
            day_profit_05 = day_profit_05_median;
            day_profit_95 = day_profit_05_median;
        case 'mean' 
            day_profit_05 = day_profit_95_mean;
            day_profit_95 = day_profit_95_mean;
        case 'std'  
            day_profit_05 = day_profit_05_std;
            day_profit_95 = day_profit_05_std; 
    end

    %%%%%%%%%%%%%%%%%%%%%%%% Other risk measures %%%%%%%%%%%%%%%%%%%%%%
    % VaR 
    VaR_95_historical_05 = quantile(day_profit_05,0.05);
    VaR_95_historical_95 = quantile(day_profit_95,0.05);
    
    % Qauntile 95%
    quantile_95_95 = quantile(day_profit_95,0.95);
    
    % Volatility
    std_05 = std(day_profit_05);
    std_95 = std(day_profit_95);
    
    % Shape ratio
    shape_ratio_weight_05 = mean(day_profit_05)/std(day_profit_05);
    shape_ratio_weight_95 = mean(day_profit_95)/std(day_profit_95);

    q50_IQR_weight_05 = quantile(day_profit_05,0.5)/ iqr(day_profit_05);
    q50_IQR_weight_95 = quantile(day_profit_95,0.5)/ iqr(day_profit_95);
    
    % Median
    median_weight_05 = quantile(day_profit_05,0.5);
    median_weight_95 = median(day_profit_95);

    % Expected shortfall
    index_weights_05 = find(day_profit_05 < VaR_95_historical_05);
    index_weights_95 = find(day_profit_95 < VaR_95_historical_95);
    help_vec_05 = zeros(1,length(index_weights_05));
    help_vec_95 = zeros(1,length(index_weights_95));
    for z = 1:length(index_weights_05)
        help_vec_05(z) = day_profit_05(index_weights_05(z));
    end
    for z = 1:length(index_weights_95)
        help_vec_95(z) = day_profit_95(index_weights_95(z));
    end
    ES_05 = mean(help_vec_05); % below VaR
    ES_95 = mean(help_vec_95); % below VaR  
    
    % Expected shortfall 95%
    index_95 = find(day_profit_95 > quantile_95_95);
    help_vec_95_95 = zeros(1,length(index_95));
    for z = 1:length(index_95)
        help_vec_95_95(z) = day_profit_95(index_95(z));
    end
    ES_95_95 = mean(help_vec_95_95); % above VaR
    
    % Expectiles 5%
    expectiles_05 = expectile(day_profit_05, 0.05);
    expectiles_95 = expectile(day_profit_95, 0.05);
    
    % Expectiles 95%
    expectiles_95_95 = expectile(day_profit_95, 0.95);
    
    % Mean
    mean_05 = mean(day_profit_05);
    mean_95 = mean(day_profit_95);
        
end