function [total_profit_wht_1, VaR_95_historical_wht_1, std_wht_1, sharpe_ratio_wht_1, q50_IQR_wht_1,median_wht_1, ES_wht_1,expectiles_wht_1,mean_wht_1]= strategy_evaluation_metrics_wht_1(real_price_RDN, real_price_RB, amount_day_3)


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Input data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % amount_day_3 - amount of day in validation's window = 390;
    % real_price_RB - real prices for the day ahead market in the third window
    % real_price_RDN - real prices for the complementary market in the third window

    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Weight 1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    weights_end  = 1;

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Hourly profit %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    profit_wht_1 = zeros(amount_day_3*24,1);

    for i = 1:amount_day_3*24
        profit_wht_1(i) = weights_end * real_price_RB(i) + (1 - weights_end)* real_price_RDN(i) - real_price_RDN(i);
    end

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Total profit %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    total_profit_wht_1 = sum(profit_wht_1);

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 5% Value atRisk (VaR) %%%%%%%%%%%%%%%%%%%%%%
    day_profit_wht_1 = zeros(amount_day_3,1);

    for k = 1:amount_day_3  
        day_profit_wht_1(k) = sum(profit_wht_1((k-1)*24+1:k*24)); % było 'sum'
    end

    % VaR 
    VaR_95_historical_wht_1 = quantile(day_profit_wht_1,0.05);
    
    % Volatility
    std_wht_1 = std(day_profit_wht_1);
    
    % Shape ratio
    sharpe_ratio_wht_1 = mean(day_profit_wht_1)/std(day_profit_wht_1);
    
    q50_IQR_wht_1 = quantile(day_profit_wht_1,0.5)/iqr(day_profit_wht_1);
    
    % Median
    median_wht_1 = median(day_profit_wht_1);
    
    % Expected shortfall
    index = find(day_profit_wht_1 < VaR_95_historical_wht_1);
    help_vec = zeros(1,length(index));
    for z = 1:length(index)
        help_vec(z) = day_profit_wht_1(index(z));
    end
    
    ES_wht_1 = mean(help_vec);  % below VaR
    
    % Expectiles 5%
    expectiles_wht_1 = expectile(day_profit_wht_1,0.05);
    
    % Mean
    mean_wht_1 = mean(day_profit_wht_1);
   
end
