clear all
close all

data = importdata('data_Poland_20170101_20201231.txt');

start = 1;                                  % choose the first hour in calibration's window
endd_1 = 371*24;                            % choose the last hour to calibrate the individual model
endd_2 = 366*24;                            % choose the last hour in second window
endd = endd_1 + endd_2;                     % choose the last hour in calibration's window
amount_day_2  = 366;                        % amount of day only in the second window; 
amount_day_3 = 724;                         % amount of day in the third window ;
amount_day = amount_day_2 + amount_day_3;   % amount of day in the second and third window
option = '1';                               % method of finding value of w_ht, which maximalize s_ht
nr_U = 730; %371+366-7;                     % number of scenarios
nr_model = 9;                               % number of models
measures = {'quantile','std', 'expectiles','ES', 'sharpe', 'q_50_IQR', 'median', 'mean', 'std'};  % measure of risk

list_m = {'1','2','3','4','5','6','7','8','9'}; % list of models
real_price_RDN = data(endd+1:end,3);        % real prices for the day ahead market in the third window
real_price_RB = data(endd+1:end,4);         % real prices for the complementary market in the third window
prediction_QRA_RB = importdata('prediction_QRA_RB_Poland.txt');    % prediction prices using quantile regression method for the day ahead market
prediction_QRA_RDN = importdata('prediction_QRA_RDN_Poland.txt');  % prediction prices using quantile regression method for the complementary market
fname = 'plots_overleaf_fig';               % folder to save figures

weights_all = [0.0789,0.0698,0.0207,0.0011,0.0021,0.0304,0.9259,0.9045,0.9576,0.5330,0.5739];  % fixed weights                        

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%% Prediction quantile %%%%%%%%%%%%%%%%%%%%%%%%%%

% [prediction_QRA_RDN, prediction_QRA_RB] = prediction_quantile_RDN_RB(data, start, endd_1, endd_2, amount_day, amount_day_3);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%% Interpolation quantile %%%%%%%%%%%%%%%%%%%%%%%%%%

% [price_scenario_RB, price_scenario_RDN] = interpolation_quantile_regression_RDN_RB(prediction_QRA_RB, prediction_QRA_RDN, amount_day_3, nr_U);
     
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%% Optimal scenarios  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% % For the QRA model  
% final_weights_QRA_quantile = optimal_scenarios_measure(prediction_QRA_RB, prediction_QRA_RDN,amount_day_3, nr_U, option, 'quantile');
% final_weights_QRA_expectiles = optimal_scenarios_measure(prediction_QRA_RB, prediction_QRA_RDN,amount_day_3, nr_U, option, 'expectiles');
% final_weights_QRA_ES = optimal_scenarios_measure(prediction_QRA_RB, prediction_QRA_RDN,amount_day_3, nr_U, option, 'ES');
% final_weights_QRA_sharpe = optimal_scenarios_measure(prediction_QRA_RB, prediction_QRA_RDN,amount_day_3, nr_U, option, 'sharpe');
% final_weights_QRA_q_50_IQR = optimal_scenarios_measure(prediction_QRA_RB, prediction_QRA_RDN,amount_day_3, nr_U, option, 'q_50_IQR');
% final_weights_QRA_median = optimal_scenarios_measure(prediction_QRA_RB, prediction_QRA_RDN,amount_day_3, nr_U, option, 'median');
% final_weights_QRA_mean = optimal_scenarios_measure(prediction_QRA_RB, prediction_QRA_RDN,amount_day_3, nr_U, option, 'mean');
% final_weights_QRA_std = optimal_scenarios_measure(prediction_QRA_RB, prediction_QRA_RDN,amount_day_3, nr_U, option, 'std');


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%% Strategy evaluation metrics %%%%%%%%%%%%%%%%%%%%%%%%%%
%  
% % For the QRA model 
% profit_VaR_weight_QRA_model = zeros(length(measures),6);
% 
% for k = 1:length(measures)
%     measure = cell2mat(measures(k));
%     [total_profit_05, total_profit_95, VaR_95_historical_05,VaR_95_historical_95, mean_weight_05,  mean_weight_95]= strategy_evaluation_metrics(real_price_RDN, real_price_RB, amount_day_3, nr_U, option, prediction_QRA_RB, prediction_QRA_RDN, measure);
%     profit_VaR_weight_QRA_model(k,1) = total_profit_05;
%     profit_VaR_weight_QRA_model(k,2) = total_profit_95;
%     profit_VaR_weight_QRA_model(k,3) = VaR_95_historical_05;
%     profit_VaR_weight_QRA_model(k,4) = VaR_95_historical_95;
%     profit_VaR_weight_QRA_model(k,5) = mean_weight_05;
%     profit_VaR_weight_QRA_model(k,6) = mean_weight_95;
% end
% profit_VaR_weight_QRA_model_fin = [measures' num2cell(profit_VaR_weight_QRA_model)];
% risk_measure_name = {'risk measures','profit (risk min strat.)', 'profit (profit max strat.)', 'VaR (risk min strat.)', 'VaR (profit max strat.)', 'mean weight (risk min strat.)', 'mean weight (profit max strat.)'};
% profit_VaR_weight_QRA_model_final = [risk_measure_name; profit_VaR_weight_QRA_model_fin];



% %%%%%%%%%%%%%%%%%%%%%%%%%% For weight 1 %%%%%%%%%%%%%%%%%%%%%%%%%
% 
% [total_profit_wht_1, VaR_95_historical_wht_1, std_wht_1, sharpe_ratio_wht_1, q50_IQR_wht_1,median_wht_1, ES_wht_1,expectiles_wht_1,mean_wht_1]= strategy_evaluation_metrics_wht_1(real_price_RDN, real_price_RB, amount_day_3)
% 
% Strategy = {'Weight equal to 1'};
% total_profit = [total_profit_wht_1];
% VaR_95 = [VaR_95_historical_wht_1];
% std = [std_wht_1];
% shape_ratio = [sharpe_ratio_wht_1];
% q50_IQR = [q50_IQR_wht_1];
% median = [median_wht_1];
% ES = [ES_wht_1];
% expectiles = [expectiles_wht_1];
% mean_05 = [mean_wht_1];
% 
% Weight_1 = table(Strategy, total_profit, VaR_95, std, shape_ratio,q50_IQR, median, ES, expectiles, mean_05);  
% 

% %%%%%%%%%%%%%%%%%%%%%%%%% For fix weights %%%%%%%%%%%%%%%%%%%%%%%
% 
% results_fix_weight_QRA = zeros(length(weights_all), 12);
% 
% for i = 1:length(weights_all)
%     weights = weights_all(i);
%     [total_profit_wht_fix, VaR_95_historical_wht_fix, quantile_95_95, std_wht_fix, sharpe_ratio_wht_fix, q50_IQR_wht_fix,median_wht_fix, ES_wht_fix_05,ES_wht_fix_95, expectiles_wht_fix_05, expectiles_wht_fix_95, mean_wht_fix]= strategy_evaluation_metrics_fix_wht(real_price_RDN, real_price_RB, amount_day_3, weights);
%     results_fix_weight_QRA(i, 1) = total_profit_wht_fix;
%     results_fix_weight_QRA(i, 2) = VaR_95_historical_wht_fix;
%     results_fix_weight_QRA(i, 3) = quantile_95_95;
%     results_fix_weight_QRA(i, 4) = std_wht_fix;
%     results_fix_weight_QRA(i, 5) = sharpe_ratio_wht_fix;
%     results_fix_weight_QRA(i, 6) = q50_IQR_wht_fix;
%     results_fix_weight_QRA(i, 7) = median_wht_fix;
%     results_fix_weight_QRA(i, 8) = ES_wht_fix_05;
%     results_fix_weight_QRA(i, 9) = ES_wht_fix_95;
%     results_fix_weight_QRA(i, 10) = expectiles_wht_fix_05;
%     results_fix_weight_QRA(i, 11) = expectiles_wht_fix_95;
%     results_fix_weight_QRA(i, 12) = mean_wht_fix;
% end
% 
% evaluation = {'Evaluation','Profit', '5% VaR', '95% quantile', 'Std', 'Sharpe','MIQR','Median','5% ES', '95% ES','5% expectile', '95% expectile', 'Mean'};
% risk_measures = {'5% quantile', '5% expectile','5% ES', 'Volatility','Sharpe ratio', 'q_50_IQR', '95% quantile', '95% expectile','95% ES', 'mean', 'median'};
% results_fix_weight_QRA_f = [risk_measures' num2cell(results_fix_weight_QRA)];
% results_fix_weight_QRA_final = [evaluation; results_fix_weight_QRA_f];


%%%%%%%%%%%%%%%%%%%%%%%%% For fix weights company %%%%%%%%%%%%%%%%%%%%%%%

results_fix_weight_QRA = zeros(length(weights_all), 12);

for i = 1:length(weights_all)
    weights = weights_all(i);
    [total_profit_wht_fix, VaR_95_historical_wht_fix, quantile_95_95, std_wht_fix, sharpe_ratio_wht_fix, q50_IQR_wht_fix,median_wht_fix, ES_wht_fix_05,ES_wht_fix_95, expectiles_wht_fix_05, expectiles_wht_fix_95, mean_wht_fix]= strategy_evaluation_metrics_fix_wht_company(real_price_RDN, real_price_RB, amount_day_3, weights);
    results_fix_weight_QRA(i, 1) = total_profit_wht_fix;
    results_fix_weight_QRA(i, 2) = VaR_95_historical_wht_fix;
    results_fix_weight_QRA(i, 3) = quantile_95_95;
    results_fix_weight_QRA(i, 4) = std_wht_fix;
    results_fix_weight_QRA(i, 5) = sharpe_ratio_wht_fix;
    results_fix_weight_QRA(i, 6) = q50_IQR_wht_fix;
    results_fix_weight_QRA(i, 7) = median_wht_fix;
    results_fix_weight_QRA(i, 8) = ES_wht_fix_05;
    results_fix_weight_QRA(i, 9) = ES_wht_fix_95;
    results_fix_weight_QRA(i, 10) = expectiles_wht_fix_05;
    results_fix_weight_QRA(i, 11) = expectiles_wht_fix_95;
    results_fix_weight_QRA(i, 12) = mean_wht_fix;
end

evaluation = {'Evaluation','Profit', '5% VaR', '95% quantile', 'Std', 'Sharpe','MIQR','Median','5% ES', '95% ES','5% expectile', '95% expectile', 'Mean'};
risk_measures = {'5% quantile', '5% expectile','5% ES', 'Volatility','Sharpe ratio', 'q_50_IQR', '95% quantile', '95% expectile','95% ES', 'mean', 'median'};
results_fix_weight_QRA_f = [risk_measures' num2cell(results_fix_weight_QRA)];
results_fix_weight_QRA_final = [evaluation; results_fix_weight_QRA_f];



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Plots %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% plots_data(data,endd_1, endd_2, real_price_RDN, real_price_RB, prediction_QRA_RB, prediction_QRA_RDN,amount_day_3, nr_U, option, fname);

