function [price_scenario_RB, price_scenario_RDN] = interpolation_quantile_regression_RDN_RB(prediction_QRA_RB, prediction_QRA_RDN, amount_day_3, nr_U)
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Input data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    % prediction_QRA_RB - quantile regression for RB market
    % prediction_QRA_RDN - quantile regression for RDN market
    % amount_day_3 - amount of day in validation's window (third window) 
    % nr_U - number of scenarios 

    % % %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % % %%%%%%%%%%%%%%%%% Interpolation a single day-ahead price %%%%%%%%%%%%%%
     
    q = 0.01:0.01:0.99;
    
    price_scenario_RB = zeros(amount_day_3*24, nr_U);    % matrix with different scenarios for each hour
    price_scenario_RDN = zeros(amount_day_3*24, nr_U);    % matrix with different scenarios for each hour

    U = rand(1,nr_U);
    for k = 1: amount_day_3
        
        index_q_minus = [];
        index_q_plus = [];
        for i = 1:length(U)
            k1 = find(q<U(i));
            if isempty(k1)
             k1=1;
            end
            index_q_minus = [index_q_minus, k1(end)];
            k2 = find(q>U(i));
            if isempty(k2)
                k2=length(q);
            end    
            index_q_plus = [index_q_plus,k2(1)];
        end

         for i = 1:length(U)
           if q(index_q_plus(i))==q(index_q_minus(i))
                price_scenario_RB((k-1)*24+1:k*24,i) = prediction_QRA_RB((k-1)*24+1:k*24,index_q_plus(i));
                price_scenario_RDN((k-1)*24+1:k*24,i) = prediction_QRA_RDN((k-1)*24+1:k*24,index_q_plus(i));
           else
                price_scenario_RB((k-1)*24+1:k*24,i) = prediction_QRA_RB((k-1)*24+1:k*24,index_q_plus(i)) *(q(index_q_plus(i))-U(i))/(q(index_q_plus(i))-q(index_q_minus(i)))+ prediction_QRA_RB((k-1)*24+1:k*24,index_q_minus(i))*(U(i)-q(index_q_minus(i)))/(q(index_q_plus(i))-q(index_q_minus(i)));
                price_scenario_RDN((k-1)*24+1:k*24,i) = prediction_QRA_RDN((k-1)*24+1:k*24,index_q_plus(i)) *(q(index_q_plus(i))-U(i))/(q(index_q_plus(i))-q(index_q_minus(i)))+ prediction_QRA_RDN((k-1)*24+1:k*24,index_q_minus(i))*(U(i)-q(index_q_minus(i)))/(q(index_q_plus(i))-q(index_q_minus(i)));
           end
         end
    end   
end