function [prediction_QRA_RDN, prediction_QRA_RB] = prediction_quantile_RDN_RB(data, start, endd_1, endd_2, amount_day, amount_day_3)


    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Input data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    % data - input data
    % start - choose the first hour in calibration's window 
    % endd_1 - choose the last hour to calibrate the individual model
    % endd_2 - choose the last hour in second window 
    % amount_day - amount of day in the second and third window 
    % amount_day_3 - amount of day in validation's window (third window) 
    % save prediction_QRA_RDN_340.txt prediction_QRA_RDN -ascii -  method
    % to save the obtained results
 
  
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%% Calculate the point forecast for all 9 models %%%%%%%%%%%%%
    
    matrix_predict_RDN = zeros(amount_day*24,9);  % in rows predicted price, in columns - different models
    matrix_predict_RB = zeros(amount_day*24,9);
    list_m = ['1','2','3','4','5','6','7','8','9'];
    for m = 1:length(list_m)
        for k = 1:amount_day
           % Estimation of model 
            forecast_for_day_RDN = model_ARX_RDN(data(start+(k-1)*24:endd_1+k*24,:),num2str(m));
            forecast_for_day_RB = model_ARX_RB(data(start+(k-1)*24:endd_1+k*24,:),num2str(m));
           
            % Calculate the point forecast for 1090 data points.
            matrix_predict_RDN((k-1)*24+1:k*24,m) = forecast_for_day_RDN;
            matrix_predict_RB((k-1)*24+1:k*24,m) = forecast_for_day_RB;
        end
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%%%%%%%%%% Calculate quantile regression %%%%%%%%%%%%%%%%%%%%
    
    q = 0.01:0.01:0.99;
    prediction_QRA_RB = zeros(amount_day_3*24,length(q));
    prediction_QRA_RDN = zeros(amount_day_3*24,length(q));
    real_price_RDN = data(endd_1+1:end,3);
    real_price_RB = data(endd_1+1:end,4);
    
    for hour = 1:24
        for tau  = 1:length(q)
            for day = 1:amount_day_3
                w = quantreg(matrix_predict_RB(hour+(day-1)*24:24:endd_2+(day-1)*24,:), real_price_RB(hour+(day-1)*24:24:endd_2+(day-1)*24), q(tau));
                w1 = quantreg(matrix_predict_RDN(hour+(day-1)*24:24:endd_2+(day-1)*24,:), real_price_RDN(hour+(day-1)*24:24:endd_2+(day-1)*24), q(tau));
                prediction_QRA_RB(hour+(day-1)*24,tau) = matrix_predict_RB(endd_2 + hour + (day-1)*24,:)*w;
                prediction_QRA_RDN(hour+(day-1)*24,tau) = matrix_predict_RDN(endd_2 + hour + (day-1)*24,:)*w1; 
            end
        end
    end
end